"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IsoCode = void 0;
const typeorm_1 = require("typeorm");
const enumConstant_1 = require("../utils/enumConstant");
const Site_1 = require("./Site");
const UserRegion_1 = require("./UserRegion");
let IsoCode = class IsoCode {
    constructor(config) {
        if (config) {
            Object.assign(this, Object.assign({}, config));
        }
    }
};
__decorate([
    typeorm_1.PrimaryGeneratedColumn(),
    __metadata("design:type", Number)
], IsoCode.prototype, "id", void 0);
__decorate([
    typeorm_1.Column({ length: 50 }),
    __metadata("design:type", String)
], IsoCode.prototype, "code", void 0);
__decorate([
    typeorm_1.Column(),
    __metadata("design:type", String)
], IsoCode.prototype, "name", void 0);
__decorate([
    typeorm_1.Column('tinyint', { default: enumConstant_1.EStatus.active }),
    __metadata("design:type", Number)
], IsoCode.prototype, "status", void 0);
__decorate([
    typeorm_1.Column('decimal', { precision: 11, scale: 8, nullable: true }),
    __metadata("design:type", Number)
], IsoCode.prototype, "latitude", void 0);
__decorate([
    typeorm_1.Column('decimal', { precision: 11, scale: 8, nullable: true }),
    __metadata("design:type", Number)
], IsoCode.prototype, "longitude", void 0);
__decorate([
    typeorm_1.Column({ type: 'timestamp', nullable: false, default: () => 'CURRENT_TIMESTAMP' }),
    __metadata("design:type", Date)
], IsoCode.prototype, "created_at", void 0);
__decorate([
    typeorm_1.Column({ type: 'timestamp', nullable: false, default: () => 'CURRENT_TIMESTAMP' }),
    __metadata("design:type", Date)
], IsoCode.prototype, "updated_at", void 0);
__decorate([
    typeorm_1.OneToMany(() => Site_1.Site, site => site.region),
    __metadata("design:type", Array)
], IsoCode.prototype, "sites", void 0);
__decorate([
    typeorm_1.OneToMany(() => UserRegion_1.UserRegion, user_region => user_region.region),
    __metadata("design:type", Array)
], IsoCode.prototype, "user_regions", void 0);
IsoCode = __decorate([
    typeorm_1.Entity(),
    __metadata("design:paramtypes", [Object])
], IsoCode);
exports.IsoCode = IsoCode;
//# sourceMappingURL=IsoCode.js.map