import { EStatus } from '../utils/enumConstant';
import { Building } from './Building';
import { LiftAssignee } from './LiftAssignee';
import { Site } from './Site';
import { Task } from './Task';
export declare class Lift {
    constructor(config?: {
        [P in keyof Lift]?: Lift[P];
    });
    id: number;
    site: Site;
    building: Building;
    lift_no: number;
    lift_contract_no: string;
    line_no: number;
    model_no: string;
    machine_room_no: number;
    floor_list: string;
    description: any;
    type: number;
    scope_lift_monitoring: number | boolean;
    warranty_from: Date;
    warranty_to: Date;
    status: number;
    active: EStatus;
    latitude: number;
    longitude: number;
    performance: number;
    created_at: Date;
    updated_at: Date;
    last_checked_at: Date;
    assignees: LiftAssignee[];
    tasks: Task[];
}
