"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Lift = void 0;
const typeorm_1 = require("typeorm");
const enumConstant_1 = require("../utils/enumConstant");
const Building_1 = require("./Building");
const LiftAssignee_1 = require("./LiftAssignee");
const Site_1 = require("./Site");
const Task_1 = require("./Task");
let Lift = class Lift {
    constructor(config) {
        if (config) {
            Object.assign(this, Object.assign({}, config));
        }
    }
};
__decorate([
    typeorm_1.PrimaryGeneratedColumn(),
    __metadata("design:type", Number)
], Lift.prototype, "id", void 0);
__decorate([
    typeorm_1.ManyToOne(() => Site_1.Site, site => site.lifts),
    typeorm_1.JoinColumn({ name: 'site_id' }),
    __metadata("design:type", Site_1.Site)
], Lift.prototype, "site", void 0);
__decorate([
    typeorm_1.ManyToOne(() => Building_1.Building, buiding => buiding.lifts),
    typeorm_1.JoinColumn({ name: 'building_id' }),
    __metadata("design:type", Building_1.Building)
], Lift.prototype, "building", void 0);
__decorate([
    typeorm_1.Column('int'),
    __metadata("design:type", Number)
], Lift.prototype, "lift_no", void 0);
__decorate([
    typeorm_1.Column({ unique: true }),
    __metadata("design:type", String)
], Lift.prototype, "lift_contract_no", void 0);
__decorate([
    typeorm_1.Column({ type: 'int', nullable: true }),
    __metadata("design:type", Number)
], Lift.prototype, "line_no", void 0);
__decorate([
    typeorm_1.Column(),
    __metadata("design:type", String)
], Lift.prototype, "model_no", void 0);
__decorate([
    typeorm_1.Column({ type: 'int', nullable: true }),
    __metadata("design:type", Number)
], Lift.prototype, "machine_room_no", void 0);
__decorate([
    typeorm_1.Column(),
    __metadata("design:type", String)
], Lift.prototype, "floor_list", void 0);
__decorate([
    typeorm_1.Column({
        nullable: true,
        type: 'varchar',
        length: 5000,
        transformer: {
            to(value) {
                if (['[object Object]', '[object Array]'].includes(Object.prototype.toString.call(value))) {
                    return JSON.stringify(value);
                }
                else {
                    return value;
                }
            },
            from(value) {
                try {
                    return JSON.parse(value);
                }
                catch (e) {
                    if (value) {
                        return [value];
                    }
                    return [];
                }
            },
        },
    }),
    __metadata("design:type", Object)
], Lift.prototype, "description", void 0);
__decorate([
    typeorm_1.Column({ type: 'tinyint', nullable: false }),
    __metadata("design:type", Number)
], Lift.prototype, "type", void 0);
__decorate([
    typeorm_1.Column({
        type: 'tinyint',
        nullable: false,
        default: 0,
        transformer: {
            to(value) {
                if (Object.prototype.toString.call(value) === '[object Boolean]') {
                    return value ? 1 : 0;
                }
                return value ? 1 : 0;
            },
            from(value) {
                return !!value;
            },
        },
    }),
    __metadata("design:type", Object)
], Lift.prototype, "scope_lift_monitoring", void 0);
__decorate([
    typeorm_1.Column({ type: 'timestamp', nullable: false }),
    __metadata("design:type", Date)
], Lift.prototype, "warranty_from", void 0);
__decorate([
    typeorm_1.Column({ type: 'timestamp', nullable: false }),
    __metadata("design:type", Date)
], Lift.prototype, "warranty_to", void 0);
__decorate([
    typeorm_1.Column('tinyint'),
    __metadata("design:type", Number)
], Lift.prototype, "status", void 0);
__decorate([
    typeorm_1.Column('tinyint', { default: 1 }),
    __metadata("design:type", Number)
], Lift.prototype, "active", void 0);
__decorate([
    typeorm_1.Column('decimal', { precision: 11, scale: 8 }),
    __metadata("design:type", Number)
], Lift.prototype, "latitude", void 0);
__decorate([
    typeorm_1.Column('decimal', { precision: 11, scale: 8 }),
    __metadata("design:type", Number)
], Lift.prototype, "longitude", void 0);
__decorate([
    typeorm_1.Column('decimal', { precision: 5, scale: 2, nullable: true }),
    __metadata("design:type", Number)
], Lift.prototype, "performance", void 0);
__decorate([
    typeorm_1.Column({ type: 'timestamp', nullable: false, default: () => 'CURRENT_TIMESTAMP' }),
    __metadata("design:type", Date)
], Lift.prototype, "created_at", void 0);
__decorate([
    typeorm_1.Column({ type: 'timestamp', nullable: false, default: () => 'CURRENT_TIMESTAMP' }),
    __metadata("design:type", Date)
], Lift.prototype, "updated_at", void 0);
__decorate([
    typeorm_1.Column({ type: 'timestamp', nullable: false, default: () => 'CURRENT_TIMESTAMP' }),
    __metadata("design:type", Date)
], Lift.prototype, "last_checked_at", void 0);
__decorate([
    typeorm_1.OneToMany(() => LiftAssignee_1.LiftAssignee, lift_assignee => lift_assignee.lift),
    __metadata("design:type", Array)
], Lift.prototype, "assignees", void 0);
__decorate([
    typeorm_1.OneToMany(() => Task_1.Task, task => task.lift),
    __metadata("design:type", Array)
], Lift.prototype, "tasks", void 0);
Lift = __decorate([
    typeorm_1.Entity(),
    __metadata("design:paramtypes", [Object])
], Lift);
exports.Lift = Lift;
//# sourceMappingURL=Lift.js.map