"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Role = void 0;
const typeorm_1 = require("typeorm");
const GroupRole_1 = require("./GroupRole");
const PermissionRole_1 = require("./PermissionRole");
const UserRole_1 = require("./UserRole");
let Role = class Role {
    constructor(config) {
        if (config) {
            Object.assign(this, Object.assign({}, config));
        }
    }
};
__decorate([
    typeorm_1.PrimaryGeneratedColumn(),
    __metadata("design:type", Number)
], Role.prototype, "id", void 0);
__decorate([
    typeorm_1.ManyToOne(() => GroupRole_1.GroupRole, group_role => group_role.roles),
    typeorm_1.JoinColumn({ name: 'group_role_id' }),
    __metadata("design:type", GroupRole_1.GroupRole)
], Role.prototype, "group", void 0);
__decorate([
    typeorm_1.Column({ nullable: false, unique: true }),
    __metadata("design:type", String)
], Role.prototype, "slug", void 0);
__decorate([
    typeorm_1.Column({ nullable: false }),
    __metadata("design:type", String)
], Role.prototype, "name", void 0);
__decorate([
    typeorm_1.Column({ type: 'timestamp', nullable: false, default: () => 'CURRENT_TIMESTAMP' }),
    __metadata("design:type", Date)
], Role.prototype, "created_at", void 0);
__decorate([
    typeorm_1.Column({ type: 'timestamp', nullable: false, default: () => 'CURRENT_TIMESTAMP' }),
    __metadata("design:type", Date)
], Role.prototype, "updated_at", void 0);
__decorate([
    typeorm_1.OneToMany(() => PermissionRole_1.PermissionRole, permissionRoles => permissionRoles.role),
    __metadata("design:type", Array)
], Role.prototype, "permission_roles", void 0);
__decorate([
    typeorm_1.OneToMany(() => UserRole_1.UserRole, userRoles => userRoles.role),
    __metadata("design:type", Array)
], Role.prototype, "user_roles", void 0);
Role = __decorate([
    typeorm_1.Entity(),
    __metadata("design:paramtypes", [Object])
], Role);
exports.Role = Role;
//# sourceMappingURL=Role.js.map