import { Lift } from './Lift';
import { IsoCode } from './IsoCode';
import { UserInCharge } from './UserInCharge';
import { Building } from './Building';
import { EStatus } from '../utils/enumConstant';
export declare class Site {
    constructor(config?: {
        [P in keyof Site]?: Site[P];
    });
    id: number;
    contract_no: string;
    region: IsoCode;
    site_code: string;
    site_name: string;
    site_address: string;
    thumbnail: string;
    dong_qty: number;
    car_qty: number;
    latitude: number;
    longitude: number;
    description: string;
    installed_date: Date;
    created_at: Date;
    updated_at: Date;
    buildings: Building[];
    lifts: Lift[];
    users_in_charge: UserInCharge[];
    active: EStatus;
}
