"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Site = void 0;
const typeorm_1 = require("typeorm");
const Lift_1 = require("./Lift");
const IsoCode_1 = require("./IsoCode");
const UserInCharge_1 = require("./UserInCharge");
const Building_1 = require("./Building");
const enumConstant_1 = require("../utils/enumConstant");
let Site = class Site {
    constructor(config) {
        if (config) {
            Object.assign(this, Object.assign({}, config));
        }
    }
};
__decorate([
    typeorm_1.PrimaryGeneratedColumn(),
    __metadata("design:type", Number)
], Site.prototype, "id", void 0);
__decorate([
    typeorm_1.Index({ unique: true }),
    typeorm_1.Column(),
    __metadata("design:type", String)
], Site.prototype, "contract_no", void 0);
__decorate([
    typeorm_1.ManyToOne(() => IsoCode_1.IsoCode, iso_code => iso_code.sites),
    typeorm_1.JoinColumn({ name: 'iso_code_id' }),
    __metadata("design:type", IsoCode_1.IsoCode)
], Site.prototype, "region", void 0);
__decorate([
    typeorm_1.Column(),
    __metadata("design:type", String)
], Site.prototype, "site_code", void 0);
__decorate([
    typeorm_1.Column({ nullable: true, length: 1000 }),
    __metadata("design:type", String)
], Site.prototype, "site_name", void 0);
__decorate([
    typeorm_1.Column({ nullable: true, length: 1000 }),
    __metadata("design:type", String)
], Site.prototype, "site_address", void 0);
__decorate([
    typeorm_1.Column({ nullable: true }),
    __metadata("design:type", String)
], Site.prototype, "thumbnail", void 0);
__decorate([
    typeorm_1.Column('int'),
    __metadata("design:type", Number)
], Site.prototype, "dong_qty", void 0);
__decorate([
    typeorm_1.Column('int'),
    __metadata("design:type", Number)
], Site.prototype, "car_qty", void 0);
__decorate([
    typeorm_1.Column('decimal', { precision: 11, scale: 8 }),
    __metadata("design:type", Number)
], Site.prototype, "latitude", void 0);
__decorate([
    typeorm_1.Column('decimal', { precision: 11, scale: 8 }),
    __metadata("design:type", Number)
], Site.prototype, "longitude", void 0);
__decorate([
    typeorm_1.Column({ nullable: true, length: 5000 }),
    __metadata("design:type", String)
], Site.prototype, "description", void 0);
__decorate([
    typeorm_1.Column({ type: 'timestamp', nullable: false }),
    __metadata("design:type", Date)
], Site.prototype, "installed_date", void 0);
__decorate([
    typeorm_1.Column({ type: 'timestamp', nullable: false, default: () => 'CURRENT_TIMESTAMP' }),
    __metadata("design:type", Date)
], Site.prototype, "created_at", void 0);
__decorate([
    typeorm_1.Column({ type: 'timestamp', nullable: false, default: () => 'CURRENT_TIMESTAMP' }),
    __metadata("design:type", Date)
], Site.prototype, "updated_at", void 0);
__decorate([
    typeorm_1.OneToMany(() => Building_1.Building, building => building.site),
    __metadata("design:type", Array)
], Site.prototype, "buildings", void 0);
__decorate([
    typeorm_1.OneToMany(() => Lift_1.Lift, lift => lift.site),
    __metadata("design:type", Array)
], Site.prototype, "lifts", void 0);
__decorate([
    typeorm_1.OneToMany(() => UserInCharge_1.UserInCharge, userInCharge => userInCharge.site),
    __metadata("design:type", Array)
], Site.prototype, "users_in_charge", void 0);
__decorate([
    typeorm_1.Column('tinyint', { default: 1 }),
    __metadata("design:type", Number)
], Site.prototype, "active", void 0);
Site = __decorate([
    typeorm_1.Entity(),
    __metadata("design:paramtypes", [Object])
], Site);
exports.Site = Site;
//# sourceMappingURL=Site.js.map