"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Task = void 0;
const typeorm_1 = require("typeorm");
const Lift_1 = require("./Lift");
const TaskMedia_1 = require("./TaskMedia");
const TaskTime_1 = require("./TaskTime");
const User_1 = require("./User");
const Category_1 = require("./Category");
let Task = class Task {
    constructor(config) {
        if (config) {
            Object.assign(this, Object.assign({}, config));
        }
    }
};
__decorate([
    typeorm_1.PrimaryGeneratedColumn(),
    __metadata("design:type", Number)
], Task.prototype, "id", void 0);
__decorate([
    typeorm_1.Column({ nullable: true, length: 5000 }),
    __metadata("design:type", String)
], Task.prototype, "issue", void 0);
__decorate([
    typeorm_1.Column({
        nullable: true,
        length: 5000,
        type: 'varchar',
        transformer: {
            to(value) {
                if (Object.prototype.toString.call(value) === '[object Array]') {
                    return JSON.stringify(value);
                }
                else {
                    return value;
                }
            },
            from(value) {
                try {
                    return JSON.parse(value);
                }
                catch (e) {
                    return value ? [value] : [];
                }
            },
        },
    }),
    __metadata("design:type", Object)
], Task.prototype, "error_suggestion", void 0);
__decorate([
    typeorm_1.Column({ type: 'varchar', length: 5000, nullable: true }),
    __metadata("design:type", String)
], Task.prototype, "engineer_report", void 0);
__decorate([
    typeorm_1.Column('tinyint'),
    __metadata("design:type", Number)
], Task.prototype, "status", void 0);
__decorate([
    typeorm_1.Column('tinyint'),
    __metadata("design:type", Number)
], Task.prototype, "type", void 0);
__decorate([
    typeorm_1.Column('tinyint', { nullable: true }),
    __metadata("design:type", Number)
], Task.prototype, "rate", void 0);
__decorate([
    typeorm_1.Column({ nullable: true, length: 1000 }),
    __metadata("design:type", String)
], Task.prototype, "feedback", void 0);
__decorate([
    typeorm_1.Column({ nullable: true }),
    typeorm_1.Index(),
    __metadata("design:type", String)
], Task.prototype, "alarm_id", void 0);
__decorate([
    typeorm_1.Column({ type: 'timestamp', nullable: false, default: () => 'CURRENT_TIMESTAMP' }),
    __metadata("design:type", Date)
], Task.prototype, "created_at", void 0);
__decorate([
    typeorm_1.Column({ type: 'timestamp', nullable: false, default: () => 'CURRENT_TIMESTAMP' }),
    __metadata("design:type", Date)
], Task.prototype, "updated_at", void 0);
__decorate([
    typeorm_1.ManyToOne(() => Lift_1.Lift, lift => lift.tasks),
    typeorm_1.JoinColumn({ name: 'lift_id' }),
    __metadata("design:type", Lift_1.Lift)
], Task.prototype, "lift", void 0);
__decorate([
    typeorm_1.ManyToOne(() => User_1.User, user => user.client_tasks),
    typeorm_1.JoinColumn({ name: 'client_id' }),
    __metadata("design:type", User_1.User)
], Task.prototype, "client", void 0);
__decorate([
    typeorm_1.ManyToOne(() => Category_1.Category, cate => cate.tasks),
    typeorm_1.JoinColumn({ name: 'category_id' }),
    __metadata("design:type", Category_1.Category)
], Task.prototype, "category", void 0);
__decorate([
    typeorm_1.ManyToOne(() => User_1.User, user => user.engineer_task),
    typeorm_1.JoinColumn({ name: 'engineer_id' }),
    __metadata("design:type", User_1.User)
], Task.prototype, "engineer", void 0);
__decorate([
    typeorm_1.ManyToOne(() => User_1.User, user => user.operator_task),
    typeorm_1.JoinColumn({ name: 'operator_id' }),
    __metadata("design:type", User_1.User)
], Task.prototype, "operator", void 0);
__decorate([
    typeorm_1.OneToMany(() => TaskTime_1.TaskTime, task_time => task_time.task),
    __metadata("design:type", Array)
], Task.prototype, "times", void 0);
__decorate([
    typeorm_1.OneToMany(() => TaskMedia_1.TaskMedia, task_media => task_media.task),
    __metadata("design:type", Array)
], Task.prototype, "media_list", void 0);
Task = __decorate([
    typeorm_1.Entity(),
    __metadata("design:paramtypes", [Object])
], Task);
exports.Task = Task;
//# sourceMappingURL=Task.js.map