import { EUserStatus } from '../utils/enumConstant';
import { LiftAssignee } from './LiftAssignee';
import { Profile } from './Profile';
import { ProfileClient } from './ProfileClient';
import { SocialNetworkInfo } from './SocialNetworkInfo';
import { Task } from './Task';
import { UserMeta } from './UserMeta';
import { UserRole } from './UserRole';
import { UserInCharge } from './UserInCharge';
import { UserRegion } from './UserRegion';
export declare class User {
    constructor(config?: {
        [P in keyof User]?: User[P];
    });
    id: string;
    email: string;
    username: string;
    phone: string;
    phone_dial_code: string;
    slug: string;
    password: string;
    fcm_token: string;
    locale: string;
    latitude: number;
    longitude: number;
    last_location_at: Date;
    timezone: string;
    status: EUserStatus;
    created_at: Date;
    updated_at: Date;
    profile: Profile;
    profile_client: ProfileClient;
    social_network_info: SocialNetworkInfo[];
    metadata: UserMeta[];
    user_roles: UserRole[];
    assignees: LiftAssignee[];
    engineer_task: Task[];
    operator_task: Task[];
    client_tasks: Task[];
    users_in_charge: UserInCharge[];
    user_regions: UserRegion[];
}
