"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.User = void 0;
const typeorm_1 = require("typeorm");
const enumConstant_1 = require("../utils/enumConstant");
const LiftAssignee_1 = require("./LiftAssignee");
const Profile_1 = require("./Profile");
const ProfileClient_1 = require("./ProfileClient");
const SocialNetworkInfo_1 = require("./SocialNetworkInfo");
const Task_1 = require("./Task");
const UserMeta_1 = require("./UserMeta");
const UserRole_1 = require("./UserRole");
const UserInCharge_1 = require("./UserInCharge");
const UserRegion_1 = require("./UserRegion");
let User = class User {
    constructor(config) {
        if (config) {
            Object.assign(this, Object.assign({}, config));
        }
    }
};
__decorate([
    typeorm_1.PrimaryGeneratedColumn('uuid'),
    __metadata("design:type", String)
], User.prototype, "id", void 0);
__decorate([
    typeorm_1.Column({ unique: true }),
    __metadata("design:type", String)
], User.prototype, "email", void 0);
__decorate([
    typeorm_1.Column({ unique: true }),
    __metadata("design:type", String)
], User.prototype, "username", void 0);
__decorate([
    typeorm_1.Column({ unique: true }),
    __metadata("design:type", String)
], User.prototype, "phone", void 0);
__decorate([
    typeorm_1.Column({ default: '+84' }),
    __metadata("design:type", String)
], User.prototype, "phone_dial_code", void 0);
__decorate([
    typeorm_1.Column({ unique: true }),
    __metadata("design:type", String)
], User.prototype, "slug", void 0);
__decorate([
    typeorm_1.Column({ select: false }),
    __metadata("design:type", String)
], User.prototype, "password", void 0);
__decorate([
    typeorm_1.Column({ nullable: true }),
    __metadata("design:type", String)
], User.prototype, "fcm_token", void 0);
__decorate([
    typeorm_1.Column({ nullable: true }),
    __metadata("design:type", String)
], User.prototype, "locale", void 0);
__decorate([
    typeorm_1.Column('decimal', { precision: 11, scale: 8, nullable: true }),
    __metadata("design:type", Number)
], User.prototype, "latitude", void 0);
__decorate([
    typeorm_1.Column('decimal', { precision: 11, scale: 8, nullable: true }),
    __metadata("design:type", Number)
], User.prototype, "longitude", void 0);
__decorate([
    typeorm_1.Column({ type: 'timestamp', nullable: true }),
    __metadata("design:type", Date)
], User.prototype, "last_location_at", void 0);
__decorate([
    typeorm_1.Column({ default: '+07' }),
    __metadata("design:type", String)
], User.prototype, "timezone", void 0);
__decorate([
    typeorm_1.Column('tinyint', { default: 1 }),
    __metadata("design:type", Number)
], User.prototype, "status", void 0);
__decorate([
    typeorm_1.Column({ type: 'timestamp', nullable: false, default: () => 'CURRENT_TIMESTAMP' }),
    __metadata("design:type", Date)
], User.prototype, "created_at", void 0);
__decorate([
    typeorm_1.Column({ type: 'timestamp', nullable: false, default: () => 'CURRENT_TIMESTAMP' }),
    __metadata("design:type", Date)
], User.prototype, "updated_at", void 0);
__decorate([
    typeorm_1.OneToOne(() => Profile_1.Profile, profile => profile.user),
    __metadata("design:type", Profile_1.Profile)
], User.prototype, "profile", void 0);
__decorate([
    typeorm_1.OneToOne(() => ProfileClient_1.ProfileClient, profile_client => profile_client.user),
    __metadata("design:type", ProfileClient_1.ProfileClient)
], User.prototype, "profile_client", void 0);
__decorate([
    typeorm_1.OneToMany(() => SocialNetworkInfo_1.SocialNetworkInfo, social_network_info => social_network_info.user),
    __metadata("design:type", Array)
], User.prototype, "social_network_info", void 0);
__decorate([
    typeorm_1.OneToMany(() => UserMeta_1.UserMeta, user_meta => user_meta.user),
    __metadata("design:type", Array)
], User.prototype, "metadata", void 0);
__decorate([
    typeorm_1.OneToMany(() => UserRole_1.UserRole, user_role => user_role.user),
    __metadata("design:type", Array)
], User.prototype, "user_roles", void 0);
__decorate([
    typeorm_1.OneToMany(() => LiftAssignee_1.LiftAssignee, lift_assignee => lift_assignee.user),
    __metadata("design:type", Array)
], User.prototype, "assignees", void 0);
__decorate([
    typeorm_1.OneToMany(() => Task_1.Task, task => task.engineer),
    __metadata("design:type", Array)
], User.prototype, "engineer_task", void 0);
__decorate([
    typeorm_1.OneToMany(() => Task_1.Task, task => task.operator),
    __metadata("design:type", Array)
], User.prototype, "operator_task", void 0);
__decorate([
    typeorm_1.OneToMany(() => Task_1.Task, task => task.client),
    __metadata("design:type", Array)
], User.prototype, "client_tasks", void 0);
__decorate([
    typeorm_1.OneToMany(() => UserInCharge_1.UserInCharge, userInCharge => userInCharge.user),
    __metadata("design:type", Array)
], User.prototype, "users_in_charge", void 0);
__decorate([
    typeorm_1.OneToMany(() => UserRegion_1.UserRegion, user_region => user_region.user),
    __metadata("design:type", Array)
], User.prototype, "user_regions", void 0);
User = __decorate([
    typeorm_1.Entity(),
    __metadata("design:paramtypes", [Object])
], User);
exports.User = User;
//# sourceMappingURL=User.js.map