import { MigrationInterface, QueryRunner } from 'typeorm';

export class addLatLngRegion1657104861761 implements MigrationInterface {
  public async up(queryRunner: QueryRunner): Promise<void> {
    await queryRunner.query(`UPDATE iso_code
        SET latitude = (
            CASE code 
                WHEN 'VN-44' THEN 10.3686 
                WHEN 'VN-43' THEN 10.4042 
                WHEN 'VN-54' THEN 21.2731 
                WHEN 'VN-53' THEN 22.1514 
                WHEN 'VN-55' THEN 9.2833 
                WHEN 'VN-56' THEN 21.1861 
                WHEN 'VN-50' THEN 10.2333 
                WHEN 'VN-31' THEN 13.7696 
                WHEN 'VN-57' THEN 11.0042 
                WHEN 'VN-58' THEN 11.5349 
                WHEN 'VN-40' THEN 10.9375 
                WHEN 'VN-59' THEN 9.1833 
                WHEN 'VN-04' THEN 22.6731 
                WHEN 'VN-33' THEN 12.6667 
                WHEN 'VN-72' THEN 12.0042 
                WHEN 'VN-71' THEN 21.3833 
                WHEN 'VN-39' THEN 10.9277 
                WHEN 'VN-45' THEN 10.4603 
                WHEN 'VN-30' THEN 13.9715 
                WHEN 'VN-03' THEN 22.8233 
                WHEN 'VN-63' THEN 20.5453 
                WHEN 'VN-23' THEN 18.3431 
                WHEN 'VN-61' THEN 20.9399 
                WHEN 'VN-73' THEN 9.7833 
                WHEN 'VN-14' THEN 20.8175 
                WHEN 'VN-66' THEN 20.6464 
                WHEN 'VN-34' THEN 12.2495 
                WHEN 'VN-47' THEN 10.0125 
                WHEN 'VN-28' THEN 14.3436 
                WHEN 'VN-01' THEN 22.3991 
                WHEN 'VN-35' THEN 11.9359 
                WHEN 'VN-09' THEN 21.8478 
                WHEN 'VN-02' THEN 22.4194 
                WHEN 'VN-41' THEN 10.5322 
                WHEN 'VN-67' THEN 20.42 
                WHEN 'VN-22' THEN 18.6733 
                WHEN 'VN-18' THEN 20.2539 
                WHEN 'VN-36' THEN 11.5643 
                WHEN 'VN-68' THEN 21.3136 
                WHEN 'VN-32' THEN 13.0869 
                WHEN 'VN-24' THEN 17.4833 
                WHEN 'VN-27' THEN 15.5667 
                WHEN 'VN-29' THEN 15.1206 
                WHEN 'VN-13' THEN 20.9514 
                WHEN 'VN-25' THEN 16.8056 
                WHEN 'VN-52' THEN 9.6 
                WHEN 'VN-05' THEN 21.327 
                WHEN 'VN-37' THEN 11.3131 
                WHEN 'VN-20' THEN 20.4461 
                WHEN 'VN-69' THEN 21.6 
                WHEN 'VN-21' THEN 19.8075 
                WHEN 'VN-26' THEN 16.4637 
                WHEN 'VN-46' THEN 10.35 
                WHEN 'VN-51' THEN 9.9369 
                WHEN 'VN-07' THEN 21.8281 
                WHEN 'VN-49' THEN 10.255 
                WHEN 'VN-70' THEN 21.31 
                WHEN 'VN-06' THEN 21.7 
                WHEN 'VN-CT' THEN 10.0333 
                WHEN 'VN-DN' THEN 16.0748 
                WHEN 'VN-HN' THEN 21.0245 
                WHEN 'VN-HP' THEN 20.8 
                WHEN 'VN-SG' THEN 10.8167
            END),
            longitude = (CASE code
                WHEN 'VN-44' THEN 105.4234 
                WHEN 'VN-43' THEN 107.1417 
                WHEN 'VN-54' THEN 106.1947 
                WHEN 'VN-53' THEN 105.8377 
                WHEN 'VN-55' THEN 105.7167 
                WHEN 'VN-56' THEN 106.0763 
                WHEN 'VN-50' THEN 106.3833 
                WHEN 'VN-31' THEN 109.2314 
                WHEN 'VN-57' THEN 106.6583 
                WHEN 'VN-58' THEN 106.8832 
                WHEN 'VN-40' THEN 108.1583 
                WHEN 'VN-59' THEN 105.15 
                WHEN 'VN-04' THEN 106.25 
                WHEN 'VN-33' THEN 108.05 
                WHEN 'VN-72' THEN 107.6907 
                WHEN 'VN-71' THEN 103.0169 
                WHEN 'VN-39' THEN 106.8681 
                WHEN 'VN-45' THEN 105.6331 
                WHEN 'VN-30' THEN 108.0147 
                WHEN 'VN-03' THEN 104.9836 
                WHEN 'VN-63' THEN 105.9122 
                WHEN 'VN-23' THEN 105.9058 
                WHEN 'VN-61' THEN 106.3309 
                WHEN 'VN-73' THEN 105.4708 
                WHEN 'VN-14' THEN 105.3375 
                WHEN 'VN-66' THEN 106.0511 
                WHEN 'VN-34' THEN 109.1908 
                WHEN 'VN-47' THEN 105.0808 
                WHEN 'VN-28' THEN 107.9789 
                WHEN 'VN-01' THEN 103.4393 
                WHEN 'VN-35' THEN 108.4429 
                WHEN 'VN-09' THEN 106.7578 
                WHEN 'VN-02' THEN 103.995 
                WHEN 'VN-41' THEN 106.4042 
                WHEN 'VN-67' THEN 106.1683 
                WHEN 'VN-22' THEN 105.6922 
                WHEN 'VN-18' THEN 105.975 
                WHEN 'VN-36' THEN 108.9886 
                WHEN 'VN-68' THEN 105.3947 
                WHEN 'VN-32' THEN 109.3086 
                WHEN 'VN-24' THEN 106.6 
                WHEN 'VN-27' THEN 108.4833 
                WHEN 'VN-29' THEN 108.7922 
                WHEN 'VN-13' THEN 107.0852 
                WHEN 'VN-25' THEN 107.0906 
                WHEN 'VN-52' THEN 105.9719 
                WHEN 'VN-05' THEN 103.9141 
                WHEN 'VN-37' THEN 106.0963 
                WHEN 'VN-20' THEN 106.3422 
                WHEN 'VN-69' THEN 105.85 
                WHEN 'VN-21' THEN 105.7764 
                WHEN 'VN-26' THEN 107.5908 
                WHEN 'VN-46' THEN 106.35 
                WHEN 'VN-51' THEN 106.3411 
                WHEN 'VN-07' THEN 105.2156 
                WHEN 'VN-49' THEN 105.9753 
                WHEN 'VN-70' THEN 105.5967 
                WHEN 'VN-06' THEN 104.8667 
                WHEN 'VN-CT' THEN 105.7833 
                WHEN 'VN-DN' THEN 108.224 
                WHEN 'VN-HN' THEN 105.8412 
                WHEN 'VN-HP' THEN 106.6667 
                WHEN 'VN-SG' THEN 106.6333
            END)
        WHERE code IN(
        'VN-44',
        'VN-43',
        'VN-54',
        'VN-53',
        'VN-55',
        'VN-56',
        'VN-50',
        'VN-31',
        'VN-57',
        'VN-58',
        'VN-40',
        'VN-59',
        'VN-04',
        'VN-33',
        'VN-72',
        'VN-71',
        'VN-39',
        'VN-45',
        'VN-30',
        'VN-03',
        'VN-63',
        'VN-23',
        'VN-61',
        'VN-73',
        'VN-14',
        'VN-66',
        'VN-34',
        'VN-47',
        'VN-28',
        'VN-01',
        'VN-35',
        'VN-09',
        'VN-02',
        'VN-41',
        'VN-67',
        'VN-22',
        'VN-18',
        'VN-36',
        'VN-68',
        'VN-32',
        'VN-24',
        'VN-27',
        'VN-29',
        'VN-13',
        'VN-25',
        'VN-52',
        'VN-05',
        'VN-37',
        'VN-20',
        'VN-69',
        'VN-21',
        'VN-26',
        'VN-46',
        'VN-51',
        'VN-07',
        'VN-49',
        'VN-70',
        'VN-06',
        'VN-CT',
        'VN-DN',
        'VN-HN',
        'VN-HP',
        'VN-SG'
        );`);
  }

  public async down(queryRunner: QueryRunner): Promise<void> {
    await queryRunner.query(`UPDATE iso_code SET latitude = NULL, longitude = NULL WHERE id > 0`)
  }
}
