import { Column, Entity, Index, PrimaryGeneratedColumn } from 'typeorm';
@Entity()
@Index(['latitude', 'longitude'], { unique: true })
export class CacheLocation {
  constructor(config?: { [P in keyof CacheLocation]?: CacheLocation[P] }) {
    if (config) {
      Object.assign(this, { ...config });
    }
  }

  @PrimaryGeneratedColumn()
  id: number;

  @Column('decimal', { precision: 11, scale: 8, nullable: true })
  latitude: number;

  @Column('decimal', { precision: 11, scale: 8, nullable: true })
  longitude: number;

  @Column({ length: 4000 })
  formatted_address: string;

  @Column({ nullable: true })
  place_id: string;
}
