import { Column, Entity, JoinColumn, ManyToOne } from 'typeorm';
import { Lift } from './Lift';
import { User } from './User';

@Entity()
export class LiftAssignee {
  constructor(config?: { [P in keyof LiftAssignee]?: LiftAssignee[P] }) {
    if (config) {
      Object.assign(this, { ...config });
    }
  }

  @ManyToOne(() => Lift, lift => lift.assignees, { primary: true })
  @JoinColumn({ name: 'lift_id' })
  lift: Lift;

  @ManyToOne(() => User, user => user.assignees, { primary: true })
  @JoinColumn({ name: 'user_id' })
  user: User;

  @Column('tinyint')
  type: number;

  @Column({ type: 'timestamp', nullable: false, default: () => 'CURRENT_TIMESTAMP' })
  created_at: Date;

  @Column({ type: 'timestamp', nullable: false, default: () => 'CURRENT_TIMESTAMP' })
  updated_at: Date;
}
