import { Column, Entity, PrimaryGeneratedColumn } from 'typeorm';

@Entity()
export class Notification {
  constructor(config?: { [P in keyof Notification]?: Notification[P] }) {
    if (config) {
      Object.assign(this, { ...config });
    }
  }

  @PrimaryGeneratedColumn()
  id: number;

  @Column({ nullable: false })
  entity_id: string;

  @Column({ nullable: false })
  sender_id: string;

  @Column({ nullable: false })
  recipient_id: string;

  @Column({ nullable: false })
  type: string;

  @Column({ nullable: true })
  title: string;

  @Column({ nullable: true })
  content: string;

  @Column({ length: 5000, nullable: true })
  data: string;

  @Column({ nullable: true })
  url: string;

  @Column({ default: false })
  is_received: boolean;

  @Column({ default: false })
  is_read: boolean;

  @Column({ type: 'timestamp', nullable: false, default: () => 'CURRENT_TIMESTAMP' })
  created_at: Date;

  @Column({ type: 'timestamp', nullable: false, default: () => 'CURRENT_TIMESTAMP' })
  updated_at: Date;
}
