import { Column, Entity, JoinColumn, ManyToOne } from 'typeorm';
import { Role } from './Role';
import { Permission } from './Permission';

@Entity()
export class PermissionRole {
  constructor(config?: { [P in keyof PermissionRole]?: PermissionRole[P] }) {
    if (config) {
      Object.assign(this, { ...config });
    }
  }

  @ManyToOne(() => Role, role => role.permission_roles, { primary: true })
  @JoinColumn({ name: 'role_id' })
  role: Role;

  @ManyToOne(() => Permission, permission => permission.permission_roles, { primary: true })
  @JoinColumn({ name: 'permission_id' })
  permission: Permission;

  @Column({ type: 'timestamp', nullable: false, default: () => 'CURRENT_TIMESTAMP' })
  created_at: Date;

  @Column({ type: 'timestamp', nullable: false, default: () => 'CURRENT_TIMESTAMP' })
  updated_at: Date;
}
