import { Column, Entity, OneToOne, JoinColumn } from 'typeorm';
import { EGender } from '../utils/enumConstant';
import { User } from './User';

@Entity()
export class ProfileClient {
  constructor(config?: { [P in keyof ProfileClient]?: ProfileClient[P] }) {
    if (config) {
      Object.assign(this, { ...config });
    }
  }

  @OneToOne(() => User, { primary: true })
  @JoinColumn({ name: 'user_id' })
  user: User;

  @Column({ nullable: true })
  full_name: string;

  @Column({ nullable: true, length: 1000 })
  company: string;

  @Column({ nullable: true, length: 1000 })
  address: string;

  @Column({ nullable: true, length: 5000 })
  note: string;

  @Column({ length: 10, nullable: true })
  gender: EGender;

  @Column({ nullable: true })
  dob: Date;

  @Column({ type: 'timestamp', nullable: false, default: () => 'CURRENT_TIMESTAMP' })
  created_at: Date;

  @Column({ type: 'timestamp', nullable: false, default: () => 'CURRENT_TIMESTAMP' })
  updated_at: Date;
}
