import { Column, Entity, JoinColumn, ManyToOne } from 'typeorm';
import { ESocialNetworkType } from '../utils/enumConstant';
import { User } from './User';

@Entity()
export class SocialNetworkInfo {
  constructor(config?: { [P in keyof SocialNetworkInfo]?: SocialNetworkInfo[P] }) {
    if (config) {
      Object.assign(this, { ...config });
    }
  }

  @ManyToOne(() => User, user => user.social_network_info, { primary: true })
  @JoinColumn({ name: 'user_id' })
  user: User;

  @Column({ primary: true })
  social_network_type: ESocialNetworkType;

  @Column({ nullable: true })
  social_network_id: string;

  @Column({ nullable: true, length: 1000 })
  link: string;

  @Column({ type: 'timestamp', nullable: false, default: () => 'CURRENT_TIMESTAMP' })
  created_at: Date;

  @Column({ type: 'timestamp', nullable: false, default: () => 'CURRENT_TIMESTAMP' })
  updated_at: Date;
}
