import { Column, Entity, JoinColumn, ManyToOne } from 'typeorm';
import { Media } from './Media';
import { Task } from './Task';

@Entity()
export class TaskMedia {
  constructor(config?: { [P in keyof TaskMedia]?: TaskMedia[P] }) {
    if (config) {
      Object.assign(this, { ...config });
    }
  }

  @ManyToOne(() => Task, task => task.media_list, { primary: true })
  @JoinColumn({ name: 'task_id' })
  task: Task;

  @ManyToOne(() => Media, { nullable: false, primary: true })
  @JoinColumn({ name: 'media_id' })
  media: Media;

  @Column({ type: 'timestamp', nullable: false, default: () => 'CURRENT_TIMESTAMP' })
  created_at: Date;
}
