import { Column, Entity, JoinColumn, ManyToOne, PrimaryGeneratedColumn } from 'typeorm';
import { Task } from './Task';

@Entity()
export class TaskTime {
  constructor(config?: { [P in keyof TaskTime]?: TaskTime[P] }) {
    if (config) {
      Object.assign(this, { ...config });
    }
  }

  @PrimaryGeneratedColumn()
  id: number;

  @Column({ nullable: true })
  comment: string;

  @Column({ type: 'timestamp', nullable: true })
  schedule_time: Date;

  @ManyToOne(() => Task, task => task.times)
  @JoinColumn({ name: 'task_id' })
  task: Task;

  @Column('tinyint')
  type: number;

  @Column({ type: 'timestamp', nullable: false, default: () => 'CURRENT_TIMESTAMP' })
  created_at: Date;
}
