import { Column, Entity, JoinColumn, ManyToOne } from 'typeorm';

import { User } from './User';
import { Site } from './Site';

import { EUserInChargeType } from '../utils/enumConstant';

@Entity()
export class UserInCharge {
  constructor(config?: { [P in keyof UserInCharge]?: UserInCharge[P] }) {
    if (config) {
      Object.assign(this, { ...config });
    }
  }

  @ManyToOne(() => Site, site => site.users_in_charge, { primary: true })
  @JoinColumn({ name: 'site_id' })
  site: Site;

  @ManyToOne(() => User, user => user.users_in_charge, { primary: true })
  @JoinColumn({ name: 'user_id' })
  user: User;

  @Column('tinyint', { primary: true })
  type: EUserInChargeType;

  @Column({ type: 'timestamp', nullable: false, default: () => 'CURRENT_TIMESTAMP' })
  created_at: Date;
}
