import { Column, Entity, JoinColumn, ManyToOne } from 'typeorm';
import { IsoCode } from './IsoCode';
import { User } from './User';

@Entity()
export class UserRegion {
  constructor(config?: { [P in keyof UserRegion]?: UserRegion[P] }) {
    if (config) {
      Object.assign(this, { ...config });
    }
  }

  @ManyToOne(() => User, user => user.user_regions, { primary: true })
  @JoinColumn({ name: 'user_id' })
  user: User;

  @ManyToOne(() => IsoCode, region => region.user_regions, { primary: true })
  @JoinColumn({ name: 'iso_code_id' })
  region: IsoCode;

  @Column({ type: 'timestamp', nullable: false, default: () => 'CURRENT_TIMESTAMP' })
  created_at: Date;

  @Column({ type: 'timestamp', nullable: false, default: () => 'CURRENT_TIMESTAMP' })
  updated_at: Date;
}
