import { Column, Entity, JoinColumn, ManyToOne } from 'typeorm';
import { Role } from './Role';
import { User } from './User';

@Entity()
export class UserRole {
  constructor(config?: { [P in keyof UserRole]?: UserRole[P] }) {
    if (config) {
      Object.assign(this, { ...config });
    }
  }

  @ManyToOne(() => User, user => user.user_roles, { primary: true })
  @JoinColumn({ name: 'user_id' })
  user: User;

  @ManyToOne(() => Role, role => role.user_roles, { primary: true })
  @JoinColumn({ name: 'role_id' })
  role: Role;

  @Column({ type: 'timestamp', nullable: false, default: () => 'CURRENT_TIMESTAMP' })
  created_at: Date;

  @Column({ type: 'timestamp', nullable: false, default: () => 'CURRENT_TIMESTAMP' })
  updated_at: Date;
}
